﻿using System;
using Aptify.Framework.BusinessLogic.ProcessPipeline;
using Aptify.Framework.Application;
using SOADataServices;


namespace MultipartFormDataProcessFlows
{
    public class AttachmentComponent : IProcessComponent
    {
        private AptifyApplication _app;
        //private string _filePath;

        public AttachmentComponent(/*string filePath*/)
        {
            Properties = new AptifyProperties();
            //_filePath = filePath ?? throw new ArgumentNullException(nameof(filePath));
        }

        public virtual AptifyProperties Properties { get; }
        public virtual void Config(AptifyApplication ApplicationObject)
        {
            _app = ApplicationObject ?? throw new ArgumentNullException(nameof(ApplicationObject));
        }

        public virtual SOADataServices.MultipartFormData FileData
        {
            get
            {
                var fileData = Properties["FileData"] ?? throw new ArgumentNullException("FileData");
                return fileData as SOADataServices.MultipartFormData;
            }
        }

        public virtual long RecordId
        {
            get
            {
                var RecordId = Properties["RecordId"] ?? throw new ArgumentNullException("RecordId");
                return Convert.ToInt64(RecordId);
            }
        }

        public virtual string EntityName
        {
            get
            {
                var EntityName = Properties["EntityName"] ?? throw new ArgumentNullException("EntityName");
                return Convert.ToString(EntityName);
            }
        }

        public virtual long CategoryId
        {
            get
            {
                var CategoryId = Properties["CategoryId"] ?? throw new ArgumentNullException("CategoryId");
                return Convert.ToInt32(CategoryId);
            }
        }


        public virtual string Run()
        {
            //AptifyAttachments aa = new AptifyAttachments(_app, "Persons", 10);
            AptifyAttachments aa = new AptifyAttachments(_app, EntityName, RecordId);
            //aa.AddAttachment(FileData.UploadedFiles[0].ServerLocation, "test");
            aa.AddAttachment(FileData.UploadedFiles[0].ServerLocation, CategoryId, "test");

            return ProcessFlowEngine.DefaultComponentResultCode_Success;
        }
    }
}
